'<%
'************************************************
' File:    Directory in XL.vbs (VBScript) 
' Author:  Giovanni Cenati 
'
' Mostra in un foglio di excel l'elenco dei
' files della directory trascinata sopra l'icona
' dello script.
' Shows the directory list in an excel sheet.
' http://digilander.libero.it/Cenati  Codice vbscript
' liberamente utilizzabile citando il sito.
'************************************************
Dim oXL, oFile, objArgs,path,objShell,objShellFolder,i
dim Riga ' as the excel row where to show data
Title = "Directory in Excel - Cenati Giovanni"

Set objArgs = WScript.Arguments  'Vedo se ci sono degli argomenti passati allo script
if objargs.count=0 then  'altrimenti mostro come si usa il programma
	msgbox "Trascinare una directory sul programma per averne l'elenco dei files",vbinformation+vbokonly, Title
	'msgbox "Drag a folder on the script icon to have the directory list in an excel sheet.",vbinformation+vbokonly, Title
	wscript.quit
end if
path = objArgs(0)  'questa variabile contiene il nome della directory da leggere

'Prepara l'accesso ai dati forniti dalla shell. Non funziona in Win NT4 sp6
'Creates needed objects - In WinNT Shell.app can't be instanced.
Set objShell=WScript.CreateObject("Shell.application")
Set objShellFolder=objshell.namespace(path)

'EXCEL: crea oggetto, lo rende visibile, aggiunge un foglio di lavoro.
'Creates excel sheet, make it visible, adds a workbook.
Set oXL = WScript.CreateObject("Excel.Application")
oXL.Visible = TRUE
oXL.WorkBooks.Add

'Intestazione delle colonne - Column headers
oXL.cells(1,1)= "Directory: " 
oXL.cells(1,2)= path
for i=0 to 50 'Intestazioni delle colonne - Columns headers
	oXL.cells(2, 1+i) = objShellFolder.getdetailsof(objShellFolder.items,i)
next

Riga=3
For Each oFile In objShellFolder.items  'recupero le informazioni sui files
    'Chiede a Windows alcune altre informazioni sul file.
    'Attenzione: a seconda delle versioni di windows, le colonne
    'riportano dati diversi. Con winME ho il nome + 16 attributi.
    'Warning: different OS report different data in different columns. 
    'this retrieves 50 infos + the filename (in Win ME).
    for i=0 to 50
		oXL.cells(Riga, 1+i) = objShellFolder.getdetailsof(oFile,i)
	next
    Riga=riga+1	 
Next

wscript.quit
'*** End ***